#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

#include "../NSBitmapImageRep+XPM.h"

@interface AppDelegate : NSObject
{
  NSString *_filename;
  NSImage *_image;
}
- (id) initWithImageName: (NSString *) filename;
- (void) applicationWillFinishLaunching: (NSNotification *) not;
- (void) applicationDidFinishLaunching: (NSNotification *) not;
@end

int main (int argc, const char *argv[])
{
  NSString *filename = [[[NSProcessInfo processInfo] arguments] objectAtIndex: 1];
  [NSApplication sharedApplication];
  [NSApp setDelegate: [[AppDelegate alloc] initWithImageName: filename]];

  return NSApplicationMain (argc, argv);
}

@implementation AppDelegate
- (void) dealloc
{
  [super dealloc];
}

- (id) initWithImageName: (NSString *) filename
{
  _filename = filename;
  return self;
}

- (void) applicationWillFinishLaunching: (NSNotification *) not
{
  NSMenu *menu;
  menu = AUTORELEASE([NSMenu new]);
  [menu addItemWithTitle: @"Quit"
	action: @selector (terminate:)
	keyEquivalent: @"q"];
  [NSApp setMainMenu: menu];

  _image = [[NSImage alloc] initWithContentsOfFile: _filename];
}

- (void) applicationDidFinishLaunching: (NSNotification *) not
{
  NSWindow *window;
  NSImageView *imageView;
  NSRect rect;
  NSSize size;
  unsigned int styleMask = NSTitledWindowMask | NSMiniaturizableWindowMask;

  imageView = [[NSImageView alloc] init];
  [imageView setImage: _image];
  size = [_image size];
  rect = NSMakeRect(0,0,size.width,size.height);

  window = [[NSWindow alloc] initWithContentRect: rect
			     styleMask: styleMask
			     backing: NSBackingStoreBuffered
			     defer: NO];
  [window setTitle: _filename];
  [window setContentView: imageView];

  [window makeKeyAndOrderFront: nil];
}

@end

